<?php
// +-----------------------------------------------------------------------+
// | Title plugin for piwigo                                               |
// +-----------------------------------------------------------------------+
// | Copyright(C) 2011 - 2016 ddtddt             http://temmii.com/piwigo/ |
// +-----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify  |
// | it under the terms of the GNU General Public License as published by  |
// | the Free Software Foundation                                          |
// |                                                                       |
// | This program is distributed in the hope that it will be useful, but   |
// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
// | General Public License for more details.                              |
// |                                                                       |
// | You should have received a copy of the GNU General Public License     |
// | along with this program; if not, write to the Free Software           |
// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
// | USA.                                                                  |
// +-----------------------------------------------------------------------+

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

//Add link menu
add_event_handler('get_admin_plugin_menu_links', 'metaog_admin_menu');
function metaog_admin_menu($menu){
  $menu[] = array(
    'NAME' => l10n('Metadata Open Graph'),
    'URL' => METAOG_ADMIN,
  );
    return $menu;
}

//add prefiltre photo
add_event_handler('loc_begin_admin', 'metaogPadminf',60);
add_event_handler('loc_begin_admin_page', 'metaogPadminA',60);

function metaogPadminf()
	{
	global $template;
	$template->set_prefilter('picture_modify', 'metaogPadminfT');
	}

function metaogPadminfT($content, &$smarty)
	{
  $search = '#<p style="margin:40px 0 0 0">#';
  
  $replacement = '
    <p>
      <strong>{\'Metadata Open Graph - Plugin meta og\'|@translate}</strong>
      <br>
		<br>
		<span style="margin: 0 0 0 20px">{\'Metadata Open Graph title\'|@translate}</span>
		<br>
			<input type="hidden" name="metaogidP" value="{$metaog_editP.metaogidid}">
			<input type="hidden" name="metaogidobjP" value="{$metaog_editP.metaogidobj}">
			<span style="margin: 0 0 0 20px"><input type="text" name="metaogtitlesaveP" value="{$metaog_editP.metaogtitle}" size="100" maxlenght="100"></span>
		<br>	
		<br>
			<span style="margin: 0 0 0 20px">{\'Metadata Open Graph description\'|@translate}</span>
		<br>
			<span style="margin: 0 0 0 20px"><textarea rows="2" cols="60" name="metaogdescriptionsaveP" id="metaogdescriptionsaveP" class="metaogdescriptionsaveP">{$metaog_editP.metaogdescription}</textarea></span>
		<br>	
		<br>
			<span style="margin: 0 0 0 20px">{\'Metadata Open Graph link image\'|@translate}</span>
		<br>
		  <span style="margin: 0 0 0 20px">
		  <select name="metaogimagesaveP">
			<option value="a">-----</option>
			<option value="b">{\'no photo\'|@translate}no photo</option>
			  {foreach from=$info_photos item=infophoto}
				<option value="{$infophoto.PHOTOID}" {$infophoto.PHOTOSELECT}>{$infophoto.PHOTOINFO}</option>
			  {/foreach}
		 </select>
		 </span>
		<br>
{if empty($metaog_editP.metaogpath)}<span style="margin: 0 0 0 20px">{\'use photo for this page\'|@translate}</span>{/if}	
		<br>
			<img src="{$metaog_editP.metaogpath}"><br>
		<br>	
    </p>
<p style="margin:40px 0 0 0">';

  return preg_replace($search, $replacement, $content);
	}
 
function metaogPadminA(){
  if (isset($_GET['image_id'])){
	global $template, $prefixeTable, $conf;
	$pageog=$_GET['image_id'];
    $metaog = pwg_db_fetch_assoc(pwg_query("SELECT * FROM " . METAOG_TABLE . " WHERE type = 2 AND idobj = '".$_GET['image_id']."';"));
	if(empty($metaog)){
		$metaog['id']='';
		$metaog['metaogtitle']='';
		$metaog['metaogdescription']='';
		$metaog['metaogimage']='';
	}
	$tab_picture = pwg_query('SELECT id,name,path FROM ' . IMAGES_TABLE . ' order by id;');
	if (pwg_db_num_rows($tab_picture)){
      while ($info_photos = pwg_db_fetch_assoc($tab_picture)) {
		if($info_photos['id']==$metaog['metaogimage']){
		  $select="SELECTED";
		  $metaog['path']=$info_photos['path'];
		}else{
		  $select="";
		}
		$items = array(
		  'PHOTOID' => $info_photos['id'],
		  'PHOTOINFO' => $info_photos['id'].' - '.$info_photos['name'],
		  'PHOTOSELECT' => $select,
		);
		$template->append('info_photos', $items);
      }
    }
  if (empty($metaog['metaogimage'])){unset($metaog['metaogimage']);}
  if(isset($metaog['metaogimage'])){	
	if(isset($_SERVER['HTTPS'])){if($_SERVER['HTTPS'] == 'on'){$protocol="https://";}}
	else{$protocol="http://";}
	$metaogpath=PWG_DERIVATIVE_DIR.substr($metaog['path'], 2, -4)."-".$conf['mogsize'].substr($metaog['path'],-4);
	  if (file_exists($metaogpath) AND $conf['mogsize']!='original'){
		$metaogpath=get_absolute_root_url().PWG_DERIVATIVE_DIR.substr($metaog['path'], 2, -4)."-".$conf['mogsize'].substr($metaog['path'],-4);
	  }else{
        $metaogpath=get_absolute_root_url().substr($metaog['path'],2);
	  }
	}else{
	  $metaogpath="";
	  $metaog['metaogimage']="";
	}
  $template->assign(
    'metaog_editP',
	  array(
		'metaogidid'  => $metaog['id'],
		'metaogidobj'  => $pageog,
        'metaogtitle' => $metaog['metaogtitle'],
		'metaogdescription' => $metaog['metaogdescription'],
		'metaogimage' => $metaog['metaogimage'],
		'metaogpath' => $metaogpath,
    ));
  }
  if(isset($_POST['metaogtitlesaveP']) or isset($_POST['metaogdescriptionsaveP'])or isset($_POST['metaogimagesaveP'])){
	if($_POST['metaogimagesaveP']=="a" || $_POST['metaogimagesaveP']=="b" || $_POST['metaogimagesaveP']==$_POST['metaogidobjP']){$_POST['metaogimagesaveP']='';}
	if(!empty($_POST['metaogidP'])){
	$query = '
		UPDATE ' . METAOG_TABLE . '
			SET metaogtitle= \''.$_POST['metaogtitlesaveP'].'\'
			,metaogdescription= \''.$_POST['metaogdescriptionsaveP'].'\'
			,metaogimage= \''.$_POST['metaogimagesaveP'].'\'
			WHERE id = \''.$_POST['metaogidP'].'\'
    ;';
	pwg_query($query);
	}else{
	$q = 'INSERT INTO ' . $prefixeTable . 'metaog(type,idobj,metaogtitle,metaogdescription,metaogimage)VALUES (2,"' . $_POST['metaogidobjP'] . '","' . $_POST['metaogtitlesaveP'] . '","' . $_POST['metaogdescriptionsaveP'] . '","' . $_POST['metaogimagesaveP'] .'");';
    pwg_query($q);
    }
	$metaog = pwg_db_fetch_assoc(pwg_query("SELECT * FROM " . METAOG_TABLE . " WHERE type = 2 AND idobj = '".$_POST['metaogidobjP']."';"));
  while ($info_photos = pwg_db_fetch_assoc($tab_picture)) {
		if($info_photos['id']==$metaog['metaogimage']){
		  $select="SELECTED";
		  $metaog['path']=$info_photos['path'];
		}else{
		  $select="";
		}
		$items = array(
		  'PHOTOID' => $info_photos['id'],
		  'PHOTOINFO' => $info_photos['id'].' - '.$info_photos['name'],
		  'PHOTOSELECT' => $select,
		);
	$template->append('info_photos', $items);
  }
    if (empty($metaog['metaogimage'])){unset($metaog['metaogimage']);}
	if(isset($metaog['metaogimage'])){	
	  $picturepth = pwg_db_fetch_assoc(pwg_query('SELECT path FROM ' . IMAGES_TABLE . " WHERE id = '".$_POST['metaogidobjP']."';"));
	  $metaog['path']=$picturepth['path'];
	  if(isset($_SERVER['HTTPS'])){if($_SERVER['HTTPS'] == 'on'){$protocol="https://";}}
	  else{$protocol="http://";}
	$metaogpath=PWG_DERIVATIVE_DIR.substr($metaog['path'], 2, -4)."-".$conf['mogsize'].substr($metaog['path'],-4);
	if (file_exists($metaogpath) AND $conf['mogsize']!='original'){
		$metaogpath=get_absolute_root_url().PWG_DERIVATIVE_DIR.substr($metaog['path'], 2, -4)."-".$conf['mogsize'].substr($metaog['path'],-4);
	  }else{
        $metaogpath=get_absolute_root_url().substr($metaog['path'],2);
	  }
	}else{
	  $metaogpath="";
	  $metaog['metaogimage']="";
	} 
  $template->assign(
    'metaog_editP',
	  array(
		'metaogidid'  => $metaog['id'],
		'metaogidobj'  => $pageog,
        'metaogtitle' => $metaog['metaogtitle'],
		'metaogdescription' => $metaog['metaogdescription'],
		'metaogimage' => $metaog['metaogimage'],
		'metaogpath' => $metaogpath,
    ));
}
}
	
//add prefiltre album
add_event_handler('loc_begin_admin', 'metaogAadminf', 60);
add_event_handler('loc_begin_admin_page', 'metaogAadminA', 60);

function metaogAadminf()
 {
	global $template;
	$template->set_prefilter('album_properties', 'metaogAadminfT');
 }

function metaogAadminfT($content, &$smarty)
 {
  $search = '#<p style="margin:0">#';
  
  $replacement = '
    <p>
      <strong>{\'Metadata Open Graph - Plugin meta og\'|@translate}</strong>
      <br>
		<br>
		<span style="margin: 0 0 0 20px">{\'Metadata Open Graph title\'|@translate}</span>
		<br>
			<input type="hidden" name="metaogidA" value="{$metaog_editA.metaogidid}">
			<input type="hidden" name="metaogidobjA" value="{$metaog_editA.metaogidobj}">
			<span style="margin: 0 0 0 20px"><input type="text" name="metaogtitlesaveA" value="{$metaog_editA.metaogtitle}" size="100" maxlenght="100"></span>
		<br>	
		<br>
			<span style="margin: 0 0 0 20px">{\'Metadata Open Graph description\'|@translate}</span>
		<br>
			<span style="margin: 0 0 0 20px"><textarea rows="2" cols="60" name="metaogdescriptionsaveA" id="metaogdescriptionsaveA" class="metaogdescriptionsaveA">{$metaog_editA.metaogdescription}</textarea></span>
		<br>	
		<br>
			<span style="margin: 0 0 0 20px">{\'Metadata Open Graph link image\'|@translate}</span>
		<br>
		  <span style="margin: 0 0 0 20px">
		  <select name="metaogimagesaveA">
			<option value="a">-----</option>
			<option value="b">{\'no photo\'|@translate}no photo</option>
			  {foreach from=$info_photos item=infophoto}
				<option value="{$infophoto.PHOTOID}" {$infophoto.PHOTOSELECT}>{$infophoto.PHOTOINFO}</option>
			  {/foreach}
		 </select>
		 </span>
		<br>
{if empty($metaog_editA.metaogpath)}<span style="margin: 0 0 0 20px">{\'use representative photo for this album\'|@translate}</span>{/if}	
		<br>
			<img src="{$metaog_editA.metaogpath}"><br>
		<br>	
    </p>
<p style="margin:0">';

  return preg_replace($search, $replacement, $content);
 }

function metaogAadminA(){ 
  if (isset($_GET['cat_id']) and !isset($_GET['image_id'])){
	global $template, $prefixeTable, $conf;
	$pageog=$_GET['cat_id'];
    $metaog = pwg_db_fetch_assoc(pwg_query("SELECT * FROM " . METAOG_TABLE . " WHERE type = 3 AND idobj = '".$_GET['cat_id']."';"));
	if(empty($metaog)){
		$metaog['id']='';
		$metaog['metaogtitle']='';
		$metaog['metaogdescription']='';
		$metaog['metaogimage']='';
	}
	$tab_picture = pwg_query('SELECT id,name,path FROM ' . IMAGES_TABLE . ' order by id;');
	$metaog['path']='';
	if (pwg_db_num_rows($tab_picture)){
      while ($info_photos = pwg_db_fetch_assoc($tab_picture)) {
		if($info_photos['id']==$metaog['metaogimage']){
		  $select="SELECTED";
		  $metaog['path']=$info_photos['path'];
		}else{
		  $select="";
		}
		$items = array(
		  'PHOTOID' => $info_photos['id'],
		  'PHOTOINFO' => $info_photos['id'].' - '.$info_photos['name'],
		  'PHOTOSELECT' => $select,
		);
		$template->append('info_photos', $items);
      }
    }
  if (empty($metaog['metaogimage'])){unset($metaog['metaogimage']);}
  if(isset($metaog['metaogimage'])){	
	if(isset($_SERVER['HTTPS'])){if($_SERVER['HTTPS'] == 'on'){$protocol="https://";}}
	else{$protocol="http://";}
	$metaogpath=PWG_DERIVATIVE_DIR.substr($metaog['path'], 2, -4)."-".$conf['mogsize'].substr($metaog['path'],-4);
	  if (file_exists($metaogpath) AND $conf['mogsize']!='original'){
		$metaogpath=get_absolute_root_url().PWG_DERIVATIVE_DIR.substr($metaog['path'], 2, -4)."-".$conf['mogsize'].substr($metaog['path'],-4);
	  }else{
        $metaogpath=get_absolute_root_url().substr($metaog['path'],2);
	  }
	}else{
	  $metaogpath="";
	  $metaog['metaogimage']="";
	}
  $template->assign(
    'metaog_editA',
	  array(
		'metaogidid'  => $metaog['id'],
		'metaogidobj'  => $pageog,
        'metaogtitle' => $metaog['metaogtitle'],
		'metaogdescription' => $metaog['metaogdescription'],
		'metaogimage' => $metaog['metaogimage'],
		'metaogpath' => $metaogpath,
    ));
  
  }
  if(isset($_POST['metaogtitlesaveA']) or isset($_POST['metaogdescriptionsaveA'])or isset($_POST['metaogimagesaveA'])){
	if($_POST['metaogimagesaveA']=="a"){$_POST['metaogimagesaveA']='';}
	if(!empty($_POST['metaogidA'])){
		if($_POST['metaogidobjA'] == $_POST['metaogimagesaveA']){$_POST['metaogimagesaveA']='';}
	$query = '
		UPDATE ' . METAOG_TABLE . '
			SET metaogtitle= \''.$_POST['metaogtitlesaveA'].'\'
			,metaogdescription= \''.$_POST['metaogdescriptionsaveA'].'\'
			,metaogimage= \''.$_POST['metaogimagesaveA'].'\'
			WHERE id = \''.$_POST['metaogidA'].'\'
    ;';
	pwg_query($query);
	}else{
	$q = 'INSERT INTO ' . $prefixeTable . 'metaog(type,idobj,metaogtitle,metaogdescription,metaogimage)VALUES (3,"' . $_POST['metaogidobjA'] . '","' . $_POST['metaogtitlesaveA'] . '","' . $_POST['metaogdescriptionsaveA'] . '","' . $_POST['metaogimagesaveA'] .'");';
    pwg_query($q);
    }
	$metaog = pwg_db_fetch_assoc(pwg_query("SELECT * FROM " . METAOG_TABLE . " WHERE type = 3 AND idobj = '".$_POST['metaogidobjA']."';"));
	$metaog['path']='';
  while ($info_photos = pwg_db_fetch_assoc($tab_picture)) {
		if($info_photos['id']==$metaog['metaogimage']){
		  $select="SELECTED";
		  $metaog['path']=$info_photos['path'];
		}else{
		  $select="";
		}
		$items = array(
		  'PHOTOID' => $info_photos['id'],
		  'PHOTOINFO' => $info_photos['id'].' - '.$info_photos['name'],
		  'PHOTOSELECT' => $select,
		);
	$template->append('info_photos', $items);
  }
    if (empty($metaog['metaogimage'])){unset($metaog['metaogimage']);}
	if(isset($metaog['metaogimage'])){	
	  $picturepth = pwg_db_fetch_assoc(pwg_query('SELECT path FROM ' . IMAGES_TABLE . " WHERE id = '".$_POST['metaogidobjA']."';"));
	  $metaog['path']=$picturepth['path'];
	  if(isset($_SERVER['HTTPS'])){if($_SERVER['HTTPS'] == 'on'){$protocol="https://";}}
	  else{$protocol="http://";}
	  $metaogpath=PWG_DERIVATIVE_DIR.substr($metaog['path'], 2, -4)."-".$conf['mogsize'].substr($metaog['path'],-4);
	  if (file_exists($metaogpath) AND $conf['mogsize']!='original'){
		$metaogpath=get_absolute_root_url().PWG_DERIVATIVE_DIR.substr($metaog['path'], 2, -4)."-".$conf['mogsize'].substr($metaog['path'],-4);
	  }else{
        $metaogpath=get_absolute_root_url().substr($metaog['path'],2);
	  }
	}else{
	  $metaogpath="";
	  $metaog['metaogimage']="";
	}
  $template->assign(
    'metaog_editA',
	  array(
		'metaogidid'  => $metaog['id'],
		'metaogidobj'  => $pageog,
        'metaogtitle' => $metaog['metaogtitle'],
		'metaogdescription' => $metaog['metaogdescription'],
		'metaogimage' => $metaog['metaogimage'],
		'metaogpath' => $metaogpath,
    ));
} 
}
 

?>